;
;************************************************************
;
;       COLD BOOT LOADER (IN SAME AREA AS FREE STORAGE)
;                                               12/20/82
;************************************************************
;
VERSNUM:DW      0
DIRBF:  DS      128
        IF DBLOCK
HSTBUF: DS      MAXHST
        ENDIF
;
        IF      NOT MDISK
ENDSYS:         EQU $                           ;TO MAKE ASSEMBLER HAPPY
ENDSYS1:        DW ENDSYS
        ENDIF
;
                ORG DIRBF
;
OLDPROM:
        DW      PROM+18H                ; 
        DW      PROM+6                  ; 
        DW      PROM+9                  ; 
;
BOOT1:
;
        CPI     1                       ; 
        JRZ     BOOT4                   ; early "net" proms
        MOV     A,L                     ; h&l = 0 ?
        ORA     H                       ; 
        JRNZ    BOOT4                   ; 
        PUSH    H                       ; save 0's
        LXI     H,OLDPROM               ; get old prom entry addresses
        LXI     D,CONSTATADR            ; 
        LXI     B,6                     ; 
        LDIR                            ; 
        POP     H                       ; 
BOOT4:
        SHLD    VERSNUM                 ; 
        LXI     H,SMSG                  ;PRINT OPENING MESSAGE.
        CALL    PMSG
;
;       GET DENSITY OF BOOTED DRIVE
;
        LDA     07FH                    ;ABS. ADDR. OF DENSITY FLAG
        LXI     H,PRIAMSG               ; 
        ANI     020H                    ; 
        CPI     020H                    ; IS IT A HARDISK?
        CZ      PMSG                    ; 
        LDA     07FH                    ; 
        LXI     H,DD128O                ;1.4 MSG
        CPI     0DDH                    ;1.4 CODE
        JNZ     BOOT3                   ; 
        CALL    PMSG                    ; mophadyte orphan
        JMP     FINIS4                  ; 
BOOT3:
        CPI     10H                     ; 
        JZ      PDDMSG                  ; 
        LXI     H,DD128N                ; 2.2 msg
        CALL    PMSG                    ; 
        LXI     H,DD128                 ; 
        LDA     7FH                     ; re-get code byte
        ANI     03H                     ;MASK UPPER
        ORA     A                       ; 0?
        JZ      PDDMSG                  ; 
        INR     A                       ; 
        LXI     H,DENMSG                ; 
        LXI     D,2                     ; 
LOOP:                                   ; 
        DAD     D                       ; 
        DCR     A                       ; 
        JNZ     LOOP                    ; 
        MOV     E,M                     ; 
        INX     H                       ; 
        MOV     D,M                     ;PTR IN D&E
        XCHG                            ;NOW IN H&L
PDDMSG:                                 ; 
        CALL    PMSG                    ;PRINT THE DENSITY
        LXI     H,DSMSG                 ; point at ds msg.
PSSDS:                                  ; 
        CALL    PMSG                    ; print single or double sided
        LXI     H,MINIMSG               ; 
        LDA     07FH                    ; 
        ANI     0100$0000B              ; is it a mini
        JNZ     PMINI                   ; 
        LXI     H,STDMSG                ; 
PMINI:                                  ; 
        CALL    PMSG                    ; 

        IF      MDISK
        LXI     H,2                     ; test location
        LXI     D,MMSG                  ; 
        MVI     C,8                     ; 
        MVI     A,1                     ; start with bank 1
        OUT     8                       ; 
CHKMDISK:
        DCR     C                       ; 
        JRZ     FILLBN0                 ; 
        LDAX    D                       ; 
        CMP     M                       ; 
        JRNZ    FILLBN2                 ; 
        INX     H                       ; 
        INX     D                       ; 
        JR      CHKMDISK                ; 
FILLBN0:
        LDA     1                       ; banks
        STA     BANKS                   ; 
        JMP     BNKEND0                 ; 
FILLBN2:
        XRA     A                       ; 
FILLBN4:        
        OUT     8                       ; set the address
        MVI     M,055H                  ; bits
        INR     A                       ; next bank
        CPI     9                       ; wrote to all ?
        JC      FILLBN4                 ; 
        XRA     A                       ; bank 0 again
TESTBN:
        STA     BANKS                   ; higest bank address in system
        OUT     8                       ; set the address
        MVI     M,0AAH                  ; other bits
        INR     A                       ; next bank
        OUT     8                       ; set address
        MOV     A,M                     ; if bank is there this is a 55h
        CPI     055H                    ; 
        JNZ     BANKEND                 ; 
        CMA                             ; make an 0aah
        MOV     M,A                     ; 
        MOV     A,M                     ; make sure its real memory
        CPI     0AAH                    ; by testing for cma of 55h
        JNZ     BANKEND                 ; 
        LDA     BANKS                   ; try next bank
        INR     A                       ; 
        JMP     TESTBN                  ; 
BANKEND:
        LDA     BANKS                   ; 
        ORA     A                       ; 
        JZ      BNKEND0                 ; no banks
        MVI     A,1                     ; 
        OUT     8                       ; 
        LXI     H,0                     ; 
        LXI     B,32                    ; 
        MVI     E,0                     ; 
        JR      FILLOOP2                ; 
FILLOOP:
        SBCD    FILLOOP4                ; creates no-ops
        MVI     E,0E5H                  ; 
        LXI     B,2048-32               ; 
FILLOOP2:
        MOV     M,E                     ; 
        INX     H                       ; 
        DCX     B                       ; 
        MOV     A,C                     ; 
        ORA     B                       ; 
        JRNZ    FILLOOP2                ; 
FILLOOP4:
        JR      FILLOOP                 ; 
        LXI     H,0                     ; 
        MVI     M,0FH                   ; user 15
        INX     H                       ; 
        LDA     BANKS                   ; 
        MOV     M,A                     ; 
        INX     H                       ; 
        LXI     D,MMSG                  ; 
        XCHG                            ; 
        LXI     B,7                     ; 
        LDIR                            ; 
        MVI     A,20H                   ; 
        STAX    D                       ; 
        INX     D                       ; 
        STAX    D                       ; 
        INX     D                       ; 
        STAX    D                       ; 
BNKEND0:
        LDA     BANKS                   ; 
        INR     A                       ; 
        MOV     C,A                     ; 
        MOV     B,A                     ; 
        XRA     A                       ; 
        OUT     8                       ; 
BNKEND1:
        DCR     C                       ; 
        JRZ     BNKEND2                 ; 
        ADI     24                      ; 
        JR      BNKEND1                 ; 
BNKEND2:
        DCR     A                       ; 
        STA     DSKSIZ                  ; 
        XRA     A                       ; 
BNKEND3:
        DCR     B                       ; 
        JRZ     BNKEND4                 ; 
        ADI     3                       ; 
        JR      BNKEND3                 ; 
BNKEND4:
        LXI     H,MDSIZE                ; 
        MOV     E,A                     ; 
        MVI     D,0                     ; 
        DAD     D                       ; 
        LXI     D,BANKS                 ; 
        LXI     B,3                     ; 
        LDIR                            ; 
        LXI     H,SXMSG                 ;
        CALL    PMSG                    ; 
        ENDIF                           ; if mdisk
FINIS4:
        LDA     CDISK                   ; 
        LXI     H,BRLOOP                ; boot read loop adr
        CMP     L                       ; lower byte occupies 4
        LDA     CDISK                   ; 
        JNZ     FIN5                    ; no match, is a hd
        XRA     A                       ; always flop a
FIN5:                                   ; if not flop, hd will be at cdisk
        MVI     B,15                    ; 
        LXI     H,DRIVMAP+15            ; 
UNMAP:
        CMP     M                       ; 
        JZ      UNMAPPED                ; 
        DCX     H                       ; 
        DCR     B                       ; 
        JNZ     UNMAP                   ; 
UNMAPPED:
        MOV     A,B                     ; 
        STA     BOOTDISK                ; 
        STA     CDISK                   ; in case of flop, set cdisk to 0
;
; Following routines initialize printer ports
;
DOINIT:
        LDA     CPUBAUD                 ; is 0 ?
        MOV     C,A                     ; save
        ORA     A                       ; test
        IN      0BH                     ; get switch setting
        JZ      DI10                    ; 
        ANI     0F0H                    ; mask switch setting for baud rate
        ORA     C                       ; 
DI10:
        OUT     0BH                     ; set baud for cpu channels a,b
;
        LDA     SBAUDL                  ; serial board baud setting (lower)
        OUT     03AH                    ; set baud
        LDA     SBAUDU                  ; serial board baud setting (upper)
        OUT     0BAH                    ; set baud 
;
        CALL    CONST                   ; get vers
        MVI     A,4                     ; 
        CMP     H                       ; s-100-8 ?
        JZ      LINIT4                  ; skip 8255 init if true, s100-8 uses par port
        CMP     L                       ; for keyboard input. early proms put vers in
        JZ      LINIT4                  ; backwards ie 84.4 for 4.84
;
        MVI     A,0ACH                  ; init 8255
        OUT     7                       ; cmd port
;
        MVI     A,0FFH                  ; set b port high
        OUT     5                       ; port b
;
LINIT4:
        MOV     A,L                     ; lower version
        ANI     0F0H                    ; mask code type
        CPI     90H                     ; new "C" cpu ?
        JNZ     LINIT6                  ; 
        MVI     A,2CH                   ; 
        STA     ANIBYTE                 ; 
        STA     CPIBYTE                 ; 
LINIT6:
        MVI     E,4                     ; no. of ports
        MVI     C,LISTBASE-1            ; first io status port less 2
INIZLOOP:
        LXI     H,INIZLST               ; table
        MVI     B,LCOUNT                ; table length
        INR     C                       ; point at next cmd port
        INR     C                       ; 
        OUTIR                           ; block move
        DCR     E                       ; last sio ?
        JNZ     INIZLOOP                ; go back for more
INLINE:
        MVI     E,4                     ; 
        MVI     C,(LISTBASE-1)+80H      ; upper serial io port
        MVI     A,0C9H                  ; Z-80 "ret" instruction
        STA     INLINE                  ; don't come back here
        JR      INIZLOOP                ; do it one more time
;
INIZLST:
        DB      18H                     ; channel reset
        DB      4                       ; select wr4
        DB      44H                     ; x 16 and 1 stop bit
        DB      5                       ; select wr5
        DB      0EAH                    ; dtr/, 8 bits, tx en, rts/
        DB      3                       ; select wr3
        DB      0C1H                    ; 8 bits, rx en
;
LCOUNT  EQU     $-INIZLST               ; generate table length
;
; signon messages
;
SMSG:   DB      0DH,0AH,'XOR DATA SCIENCE CP/M Vers '
        DB      MSIZE/10+'0',MSIZE MOD 10 + '0'
        DB      ' of 12.20.82 ',0
;
MDSIZE: 
        DB      '  0'
        DB      ' 48'
        DB      ' 96'
        DB      '144'
        DB      '192'
        DB      '240'
        DB      '288'
        DB      '336'
        DB      '384'
DENMSG:
        DW      DD128O
        DW      DD128N
        DW      DD256
        DW      DD512
        DW      DD1024
DD128O: DB      ' Standard 1.4 &'
DD128N: DB      ' 2.2 compatible directory',0DH,0AH,0
DD128:  DB      '128 bytes/sector',0
DD256:  DB      '256 bytes/sector',0
DD512:  DB      '512 bytes/sector',0
DD1024: DB      '1024 bytes/sector',0
DSMSG:  DB      ' double sided',0
MINIMSG:DB      ' 5"',0  
STDMSG: DB      ' 8"',0
PRIAMSG:DB      ' Hard disk',0
SXMSG:  DB      ' ('
BANKS:  DB      0,0,0
MMSG:   DB      'k MDISK)',0

        IF      MDISK
ENDSYS: EQU     $
        ENDIF
        DW      ENDSYS                  ; do not remove, used by dsysgen
;
