;
;************************************************************************
;**
;**              CP/M multi lister routine 11/20/82
;**             (Port initialization is in CBOOT.ASM)
;**
;************************************************************************
;
UPPER   EQU     TRUE                    ; true if second ser io card installed
DIABLO  EQU     FALSE                   ; true if diablo driver for list 1
;
; these are the status port address for the respective printers
;
LSTSTS0 EQU     01H                     ; status port cpu
LSTSTS1 EQU     LISTBASE+1              ; status port base address (21h)
LSTSTS2 EQU     LSTSTS1+2               ; status port serial io channel 1
LSTSTS3 EQU     LSTSTS1+4               ; status port serial io channel 2
LSTSTS4 EQU     LSTSTS1+6               ; status port serial io channel 3
LSTSTS5 EQU     06H                     ; status port cpu 8255
;
LSTSTS6 EQU     LISTBASE+81H            ; status port upper board address (0A1h)
LSTSTS7 EQU     LSTSTS6+2               ; status port serial io channel 1
LSTSTS8 EQU     LSTSTS6+4               ; status port serial io channel 2
LSTSTS9 EQU     LSTSTS6+6               ; status port serial io channel 3
;
; These are the data port address for the respective printers
;
LSTDAT0 EQU     00H                     ; data port cpu
LSTDAT1 EQU     LISTBASE                ; data port base address (20h)
LSTDAT2 EQU     LSTDAT1+2               ; data port serial io channel 1
LSTDAT3 EQU     LSTDAT1+4               ; data port serial io channel 2
LSTDAT4 EQU     LSTDAT1+6               ; data port serial io channel 3
LSTDAT5 EQU     04H                     ; data port cpu 8255 (parrallel centronics)
;
LSTDAT6 EQU     LISTBASE+80H            ; data port upper board address (0A0h)
LSTDAT7 EQU     LSTDAT6+2               ; data port serial io channel 1
LSTDAT8 EQU     LSTDAT6+4               ; data port serial io channel 2
LSTDAT9 EQU     LSTDAT6+6               ; data port serial io channel 3
;
ANIBYTE DB      85H                     ; 
CPIBYTE DB      85H                     ; 
;
LIST:
        MOV     B,C                     ; save output byte
        LDA     PRINTER                 ; find curent list number
        ANI     07H                     ; 
        RAL                             ; double it
        LXI     H,TABLE                 ; point at list rountine table
        MVI     D,0                     ; 
        MOV     E,A                     ; move list number into e
        DAD     D                       ; 
        MOV     E,M                     ; 
        INX     H                       ; 
        MOV     D,M                     ; we now have the address of the data
        XCHG                            ; out rountine of the current list device
        MVI     E,2CH                   ; 
        MOV     D,E                     ; 
        PCHL                            ; do it to it
;
; this printer port is channel 'A' on the cpu
;
LISTER0:
        CALL    STAT0                   ; 
        INR     A                       ; 
        JRNZ    LISTER0                 ; 
        MOV     A,B                     ; 
        OUT     LSTDAT0                 ; 
        RET                             ; 
;
        IF      DIABLO
;
; this routine is to be used for the DIABLO 1620 printer.
; buad rate for the DIABLO is normally set to 1200 baud.
; 
LISTER1:
        MVI     A,10H                   ;
        OUT     LSTSTS1                 ; 
        IN      LSTSTS1                 ;CHECK STAT
        ANI     01H                     ;RECIEVE BIT ON?
        JRZ     CHKBUF                  ;NO DATA READY
        IN      LSTDAT1                 ;SOME DATA!!
        ANI     7FH                     ;MASK PARITY
        CPI     06H                     ;ACK?
        JRZ     RSTCNT                  ;RESET COUNT THIER BUFFER EMPTY
        CPI     20H                     ;NEW LISTING
        JRZ     NEWLIST                 ;CLEAR COUNTER

CHKBUF:
        LDA     STOR                    ;CHAR SENT
        CPI     4EH                     ;1 LESS THAN MAX
        JRZ     ETXOUT                  ;SEND FIRST ETX FOR FIRST OF 2 79 BYTE SETS
        CPI     0CEH                    ;TOP OF BUFFER
        JRZ     ETXOUT1                 ;ANOTHER ETX
        CPI     0CFH                    ;TOP OF BUFFER
        JRZ     LISTER1                 ;OVER LIMIT WAIT FOR ACK

OUTDAT:
        MVI     A,10H                   ;
        OUT     LSTSTS1                 ; 
        IN      LSTSTS1                 ;CHECK STAT
        ANI     2CH                     ;
        CPI     2CH                     ; 
        JRNZ    OUTDAT                  ;STAT OK?
        MOV     A,C
OUTDAT1:
        OUT     LSTDAT1                 ; 
        LDA     STOR                    ; 
        INR     A                       ;INCREMENT BUFFER COUNT
        STA     STOR                    ; 
        RET                             ;

ETXOUT: 
        MVI     A,80H                   ;FIRST CLR OF BUFFER COUNTER USED ONCE 
        STA     STOR                    ;AT START ONLY OR NEWLST
ETXOUT1:
        MVI     A,10H                   ; this is only for sio's
        OUT     LSTSTS1                 ; 
        IN      LSTSTS1                 ;CHECK STAT
        ANI     2CH                     ;
        CPI     2CH                     ;
        JRNZ    ETXOUT1                 ;
        MVI     A,03H                   ;SET A FOR ETX OUTPUT
        CALL    OUTDAT1                 ; 
        JR      LISTER1                 ;JMP LST TO WAIT FOR ACK

NEWLIST:
        XRA     A                       ;CLEAR A TO 00H FOR NEW COUNT
        STA     STOR                    ; 
        JR      OUTDAT                  ; 

RSTCNT:
        MVI     A,80H                   ;CLR BUFFER COUNT FOR COUNT OF 80H TO CFH
        STA     STOR                    ; 
        JR      LISTER1                 ; 

STOR:   DB 00
        ELSE                            ; if diablo
;
LISTER1:        
        CALL    STAT1                   ; 
        INR     A                       ; 
        JRNZ    LISTER1                 ; 
        JR      LSTOUT                  ; 
        ENDIF                           ; if diablo
;
LISTER2:
        CALL    STAT2                   ; 
        INR     A                       ; 
        JRNZ    LISTER2                 ; 
        JR      LSTOUT                  ; 
;
LISTER3:
        CALL    STAT3                   ; 
        INR     A                       ; 
        JRNZ    LISTER3                 ; 
        JR      LSTOUT                  ; 
;
LISTER4:
        CALL    STAT4                   ; 
        INR     A                       ; 
        JRNZ    LISTER4                 ; 
;
        IF UPPER
        JR      LSTOUT                  ; 
;
LISTER6:        
        CALL    STAT6                   ; 
        INR     A                       ; 
        JRNZ    LISTER6                 ; 
        JR      LSTOUT                  ; 
;
LISTER7:
        CALL    STAT7                   ; 
        INR     A                       ; 
        JRNZ    LISTER7                 ; 
        JR      LSTOUT                  ; 
;
LISTER8:
        CALL    STAT8                   ; 
        INR     A                       ; 
        JRNZ    LISTER8                 ; 
        JR      LSTOUT                  ; 
;
LISTER9:
        CALL    STAT9                   ; 
        INR     A                       ; 
        JRNZ    LISTER9                 ; 
        ENDIF
;
LSTOUT:
        DCR     C                       ; point at data port
        OUTP    B                       ; 
        RET                             ; 
;
; this port is for a Centronics parallel interface from the CPU board.
;
LISTER5:
        IN      LSTSTS5                 ; status check
        ANI     0B0H                    ; 
        CPI     90H                     ; 
        JNZ     LISTER5                 ; 
;
TXLSTRDY5:                              ;
        MOV     A,B                     ; 
        OUT     LSTDAT5                 ;
        XRA     A                       ; strobe all 8 data lines
        OUT     05H                     ; 
        NOP!NOP!NOP!NOP                 ; lengthen pulse
        CMA                             ; 
        OUT     05H                     ; 
        RET                             ;
;
; list status routine
;
LISTST: 
        LDA     PRINTER                 ; find current list number
        ANI     07H                     ; 
        RAL                             ; double it
        LXI     H,STATTBL               ; point at status routine table
        MVI     D,0                     ; 
        MOV     E,A                     ; mov list number into e
        DAD     D                       ; 
        MOV     E,M                     ; 
        INX     H                       ; 
        MOV     D,M                     ; we now have the addrss for the status
        XCHG                            ; routine of the current list device.
        MVI     E,2CH                   ; 
        MOV     D,E                     ; 
        PCHL                            ; doit toit.
;
STAT0:
        LDA     ANIBYTE                 ; set by cboot rtn after
        MOV     E,A                     ; call to prom to get version number.
        LDA     CPIBYTE                 ; if 8251, ani and cpi bytes are 85h
        MOV     D,A                     ; 
        CPI     2CH                     ; 
        IN      LSTSTS0                 ; 
        JRNZ    STATCHK1                ; 
        MVI     C,LSTSTS0               ; 
STATCHK:
        MVI     A,10H                   ; 
        OUTP    A                       ; 
        INP     A                       ; c points to port
STATCHK1:
        MOV     L,A                     ; "printer" utility needs status in l
        ANA     E                       ; 
        CMP     D                       ; 
        MVI     A,0FFH                  ; 
        RZ                              ; 
        XRA     A                       ; 
        RET                             ; 
;
STAT1:
        MVI     C,LSTSTS1               ; 
        JR      STATCHK                 ; 
STAT2:
        MVI     C,LSTSTS2               ; 
        JR      STATCHK                 ; 
STAT3:
        MVI     C,LSTSTS3               ; 
        JR      STATCHK                 ; 
STAT4:
        MVI     C,LSTSTS4               ; 
        JR      STATCHK                 ; 
STAT5:
        IN      LSTSTS5                 ; 
        MOV     L,A                     ; for "printer" utility
        ANI     0B0H                    ; 
        CPI     90H                     ; 
        MVI     A,0FFH                  ; 
        RZ                              ; 
        CMA                             ; 
        RET                             ; 
;
        IF UPPER
;
STAT6:
        MVI     C,LSTSTS6               ; 
        JR      STATCHK                 ; 
STAT7:  
        MVI     C,LSTSTS7               ; 
        JR      STATCHK                 ; 
STAT8:
        MVI     C,LSTSTS8               ; 
        JR      STATCHK                 ; 
STAT9:
        MVI     C,LSTSTS9               ; 
        JR      STATCHK                 ; 
        ENDIF
;
; positon look-up tables.
;
; these table must match correct STATX to the the correct LISTERX
;
; X = number after STATX and LISTERX
;
STATTBL:
        DW      STAT0                   ; status routine for printer X
        DW      STAT1                   ;
        DW      STAT2                   ;
        DW      STAT3                   ;
        DW      STAT4                   ;
        DW      STAT5                   ;

        IF UPPER

        DW      STAT6                   ; 
        DW      STAT7                   ; 
        DW      STAT8                   ;  
        DW      STAT9
        ENDIF
;
TABLE:
        DW      LISTER0                 ; data out routine for printer X
        DW      LISTER1                 ;
        DW      LISTER2                 ;
        DW      LISTER3                 ;
        DW      LISTER4                 ;
        DW      LISTER5                 ;
;
        IF UPPER

        DW      LISTER6                 ; 
        DW      LISTER7                 ; 
        DW      LISTER8                 ; 
        DW      LISTER9                 ; 
        ENDIF

;end cxlst

